# -*- coding: utf-8 -*-
"""Define the menu contents, hotkeys, and event bindings.

There is additional configuration information in the EditorWindow class (and
subclasses): the menus are created there based on the menu_specs (class)
variable, and menus not created are silently skipped in the code here.  This
makes it possible, for example, to define a Debug menu which is only present in
the PythonShell window, and a Format menu which is only present in the Editor
windows.

"""
from idlelib.configHandler import idleConf

#   Warning: menudefs is altered in macosxSupport.overrideRootMenu()
#   after it is determined that an OS X Aqua Tk is in use,
#   which cannot be done until after Tk() is first called.
#   Do not alter the 'file', 'options', or 'help' cascades here
#   without altering overrideRootMenu() as well.
#       TODO: Make this more robust

menudefs = [
 # underscore prefixes character to underscore
 ('file', [
   ('_Nouveau fichier', '<<open-new-window>>'),
   ('_Ouvrir...', '<<open-window-from-file>>'),
   ('Ouvrir _Module...', '<<open-module>>'),
   ('_Browser de classes', '<<open-class-browser>>'),
   ('_Browser de chemins Path', '<<open-path-browser>>'),
   None,
   ('_Sauver', '<<save-window>>'),
   ('S_auver sous...', '<<save-window-as-file>>'),
   ('Sau_ver copie sous...', '<<save-copy-of-window-as-file>>'),
   None,
   ('Im_primer fentre', '<<print-window>>'),
   None,
   ('_Fermer', '<<close-window>>'),
   ('_Quitter', '<<close-all-windows>>'),
  ]),
 ('edit', [
   ('_Annuler', '<<undo>>'),
   ('Re_faire', '<<redo>>'),
   None,
   ('Cou_per', '<<cut>>'),
   ('_Copier', '<<copy>>'),
   ('Co_ller', '<<paste>>'),
   ('Slectionner to_ut', '<<select-all>>'),
   None,
   ('C_hercher...', '<<find>>'),
   ('Chercher _ncore', '<<find-again>>'),
   ('Chercher _slection', '<<find-selection>>'),
   ('Chercher dans fichiers...', '<<find-in-files>>'),
   ('Re_mplacer...', '<<replace>>'),
   ('Aller s_ur ligne', '<<goto-line>>'),
  ]),
('format', [
   ('_Indenter Region', '<<indent-region>>'),
   ('_Ddenter Region', '<<dedent-region>>'),
   ('C_ommenter Region', '<<comment-region>>'),
   ('Dcomme_nter Region', '<<uncomment-region>>'),
   ('Tabifier Region', '<<tabify-region>>'),
   ('Dtabifier Region', '<<untabify-region>>'),
   ('Basculer Tabs', '<<toggle-tabs>>'),
   ('Changer largeur indentation', '<<change-indentwidth>>'),
   ]),
 ('run', [
   ('Python Shell', '<<open-python-shell>>'),
   ]),
 ('shell', [
   ('_Voir dernier redmarrage', '<<view-restart>>'),
   ('_Relancer Shell', '<<restart-shell>>'),
   ]),
 ('debug', [
   ('Aller _vers fichier/ligne', '<<goto-file-line>>'),
   ('!_Debugger', '<<toggle-debugger>>'),
   ('_Visionneur de pile', '<<open-stack-viewer>>'),
   ('!_Auto-open visionneur', '<<toggle-jit-stack-viewer>>'),
   ]),
 ('options', [
   ('Configurer _IDLE', '<<open-config-dialog>>'),
   ('Configurer les e_xtensions', '<<open-config-extensions-dialog>>'),
   None,
   ]),
 ('help', [
   ('_A propos de IDLE', '<<about-idle>>'),
   None,
   ('Aide _IDLE', '<<help>>'),
   ('Python _Docs', '<<python-docs>>'),
   ]),
]

default_keydefs = idleConf.GetCurrentKeySet()
