"""
carnet.py  Version 7 (avec le Kontroleur)
Gestion de fiches de contacts avec
prenom, nom, naissance, courriel (email)
Brendan Scott 2015 VF par OE
"""

### Section Imports
import cPickle as pickle              #AJOUT

### Section Constantes
NOMFIC_SAUVE = "carnet.pickle"        #AJOUT

### Section Classes
class CarnetAdr(object):
    """ Conteneur de fiches
    """
    def __init__(self):
        """ Cree l'attribut gens comme liste vide.
        """
        self.gens = []

    def ajouter_fiche(self, fiche_nouvo):
        """ Ajoute une fiche dans gens.
        """
        self.gens.append(fiche_nouvo)

    def sauver(self):
        with open(NOMFIC_SAUVE,'w') as ficow:
            pickle.dump(self, ficow)

class FicheAdr(object):
    """ Fiche d'un contact.
    """
    def __init__(self, prenom=None, nomfami=None,
                 datenaiss=None, courriel=None):
        """Initialise les 4 attributs. Le format de
        datenaiss est JJ/MM/AAAA
        """
        self.prenom    = prenom
        self.nomfami   = nomfami
        self.datenaiss = datenaiss
        self.courriel  = courriel

    def __repr__(self):
        """ Produit une chaine selon l'objet
        FicheAdr fourni en argument self.
        """
        patron = "FicheAdr(prenom ='%s', "+\
             "nomfami ='%s',"+\
             "datenaiss ='%s', "+\
             "courriel ='%s')"
        return patron%(self.prenom,self.nomfami,
                       self.datenaiss,self.courriel)

class Kontroleur(object):  #AJOUT de toute la classe
    """ Pour gerer les donnees stockees dans une
    instance de CarnetAdr, le menu et le chargement
    des donnees du fichier.
    """
    def __init__(self):
        """
        Initialise le controleur. Cherche un fichier.
        S'il le trouve, il le lit. Sinon, il cree un
        fichier vide.
        """
        self.carnet_adr = CarnetAdr()
        contact1 = FicheAdr("Eric", "IDLE", "12/06/1999", None) #RECUP
        self.carnet_adr.ajouter_fiche(contact1) #RECUP et MODIF

    def charger(self):
        """
        Charge un carnet depuis un fichier pickle
        """
        with open(NOMFIC_SAUVE, 'r') as ficor:
            self.carnet_adr = pickle.load(ficor)

### Section Fonctions

### Section principale main
if __name__ == "__main__":
    controleur = Kontroleur()           #AJOUT
    print(controleur.carnet_adr.gens)   #MODIF
    #SUPPR Autres lignes devenues inutiles
