"""
tablesmul.py Version 6
Les tables de multiplication
Brendan Scott 2015 VF par OE
"""

#### Section des imports
import random

#### Section des constantes
Q_TEST = (4, 6)
PATRON_Q = "Combien font %s x %s ? "
MINI  = 1
MAXI  = 12
Q_MAX = 3
LIGNE_TMUL = "%2i x %2i = %3i " #MODIF

#### Section des fonctions
def creer_listeq(nmin = MINI, nmax = MAXI, hasard=True): #MODIF V3
    """ Produit une liste de questions au format (x,y)
    avec x et y entre MINI et MAXI (compris)
    """
    tempo = [(x+1, y+1) for x in range(nmin-1, nmax)
                        for y in range(nmin-1, nmax)]
    if hasard:
        random.shuffle(tempo)
    return(tempo)

def faire_test():                  #AJOUT V4
    """ Lance une passe de test """
    liste_q = creer_listeq()
    score = 0
    for i, question in enumerate(liste_q):
        if i >= Q_MAX:
            break
        invite = PATRON_Q%question
        repon_ok = question[0]*question[1]
        # Les indices commencent a 0
        repon_saisie = raw_input(invite)

        if int(repon_saisie) == repon_ok:
            print("Correct !")
            score = score+1
        else:
            print("Incorrect, il fallait trouver %s."%(repon_ok))

    print("Nombre de calculs corrects : %s"%score)

def afficher_tablesmul(nmax = MAXI): #REFONTE V6
    # Affiche la table des mult. jusque MAXI
    tab_par_lig = 5
    tab_total = range(1, nmax+1)
    # Prend un lot de 5 pour affichage
    lot_tab = tab_total[:tab_par_lig]
    # Les enleve du stock restant
    tab_total = tab_total[tab_par_lig:]
    while lot_tab != []: # Stop quand vide
        for x in range(1, nmax+1):
            # Lignes vont de 1 a 12
            accumul = []
            for y in lot_tab:
                # Construit les colonnes
                accumul.append(LIGNE_TMUL%(y, x, x*y))
            print("".join(accumul)) # Affiche une ligne
        print("\n") # Separation verticale entre blocs de tables
        # Lot suivant
        lot_tab = tab_total[:tab_par_lig]
        tab_total = tab_total[tab_par_lig:]

#### Section principale (et de test)
# Onze lignes supprimees
# faire_test()               #MODIF V5
afficher_tablesmul()         #AJOUTV5
